#include "edseq.h"
#include "extern.h"
#ifdef sparc
#include <alloca.h>
#endif
#include "../lib/faulkn.h"

int use_star = 1;

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

sq *consensus_sequence;
float consensus_threshold = 0.0;

consensus ()
{   char which [40];
    static char *list [200] = { "1-$", NULL };
/*
    win_prompt (stdscr, LINES - 2, "For which sequence group",
                which, list, 0, "Range");
*/
    text_consensus ("1-$");
}


text_consensus (which)
char *which;
{ 
    int indx, indx2, comp [256], max, *num_list, i2, count,
        num_letters;
    char *con_seq, stemp_x [400];

    con_seq = (char *) alloca (MAX_SEQ);
    if (!con_seq)
    {   printf ("ERROR - cannot alloca space in text_consensus\n");
        return;
    }
    if (consensus_threshold < 0.0)
      consensus_threshold = 0.0;
    if (consensus_threshold > 1.0)
      consensus_threshold = 1.0;
    if (!which || !*which)
      which = "1-$";

    num_list = (int *) string_to_numbers (which);
    if (!num_list)
      return;
    indx = 0; 
    do
    {   
      bzero (comp, 256 * sizeof (int));
      num_letters = 0;
      for (indx2 = 0; (i2 = num_list [indx2]) >= 0; indx2++)
        if (i2)  /*  consensus can't contrib to consensus  */
        {   i2--;
            if (indx < (entry [i2]) -> length)  {
              comp [char_set [(entry [i2] -> seq) [indx]]]++;
              num_letters++;
            }
        }
      max = -1;
      con_seq [indx] = '?';
      for (indx2 = ' '; indx2 <= '~'; indx2++)
        if ((use_gaps || (indx2 != '-')) &&
            (use_star || (indx2 != '*')))
        {   if (count = comp [indx2])
            {   if (count > max)
                {   max = count;
                    con_seq [indx] = indx2;
                }
            else if (count == max)
              con_seq [indx] = '?';
            }
        }
      if ((float) max < ((float) num_letters * consensus_threshold))  {
        con_seq [indx] = '?';
        if (comp ['-'] == num_letters)
          con_seq [indx] = '-';
        if (comp ['*'] == num_letters)
          con_seq [indx] = '*';
      }
      indx++;
    }   while (num_letters);
    indx--;
    con_seq [indx] = '\0';
    if (consensus_sequence -> length)
    {   free (consensus_sequence -> seq);
        free (consensus_sequence -> hlite);
    }
    else
      num_per_win--;
    consensus_sequence -> length = indx;
    consensus_sequence -> modified = 1;
    consensus_sequence -> allocated = indx + 100;
    consensus_sequence -> seq = emalloc (indx + 110);
    bcopy (con_seq, consensus_sequence -> seq, indx + 3);
    consensus_sequence -> hlite = emalloc (indx + 110);
    bzero (consensus_sequence -> hlite, indx + 100);
    sprintf (stemp_x, "%d", 300);
    sprintf (stemp_x, "; consensus sequence\n; for sequences %s\n",
             which);
    consensus_sequence -> comments = (char *) new_string (stemp_x);
    strcpy (consensus_sequence -> from_file, "Consensus-Sequence");
    strcpy (consensus_sequence -> locus_name, "CONSENSUS");
    save_consensus();
}

save_consensus ()
{   char out_name [300];

    out_name [0] = '\0';
    fsave_consensus (out_name);
}

fsave_consensus (out_name)
char *out_name;
{   FILE *outf;
    static char *hist [300];

    if (!consensus_sequence -> length)
    {   printf ("No consensus generated\n");
        return;
    }
    outf = w_open_file (out_name, "w", hist);
    fputs (consensus_sequence -> comments, outf);
    fprintf (outf, "%s\n", consensus_sequence -> locus_name);
    write_sequence (consensus_sequence -> seq, outf);
    fclose (outf);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

char *ProgName = NULL;

main (argc, argv)
int argc;
char **argv;
{   extern sq *consensus_sequence;
    char *tmp, *getenv ();
  
    if (tmp = getenv ("MASE_DIR"))
        strcpy (mase_dir, tmp);
    else
        strcpy (mase_dir, MASE_DIR);

    ProgName = *argv;
    if (argv [1])
      if (!strcmp (argv [1], "-T"))
      {   tmp = *argv;
	        printf ("Setting terminal to \"%s\"\n", argv [2]);
          settty (argv [2]);
          argv += 2;
          *argv = tmp;
      }

    /* do_intros (); */

    file_names = (char **) ecalloc (MAX_FILES, sizeof (char *));
    dirty_files = emalloc (MAX_FILES);
    consensus_sequence = (sq *) ecalloc (1, sizeof (sq));
    consensus_sequence -> seq = "";
    consensus_sequence -> hlite = "";

    initialize (argv);
    edit ();
    quit ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   


