#ifndef LINT
static char *sccs_sid = "@(#)decode.c	2.1 3/21/89 FAULKNLIB";
#endif

#include <stdio.h>

/*STARTDOC*/
/*  in this module:

    int decode (query, t1, t2, t3, t4 . . .)
	all char * - term arg with NULL
	test query against each arg -
	    return -1 if ambiguous
	    return -2 if not found
	    return indx if found unique
	    t1 is #0
    int vdecode (query, list)
	char *query, **list
	as decode, for pre-vectorized list
    int svdecode (query, list)
	char *query, **list
	as vdecode, uses strncmp rather than regex
	
*/

/*ENDDOC*/

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
int decode (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, 
    r, s, t, u, v, w, x, y, z)
/*  a is the query.
    returns index of unique member matching string a
    returns -1 if ambiguous, -2 if not found.
    string b is considered to be index 0
*/
char *a, *b, *c, *d, *e, *f, *g, *h, *i, *j, *k, *l, *m, *n, *o, 
    *p, *q, *r, *s, *t, *u, *v, *w, *x, *y, *z;
/*ENDDOC*/
{   char *vec [200];

    vectorize (vec, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r,
    	s, t, u, v, w, x, y, z);
    return (vdecode (a, vec));
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
int svdecode (a, vec)
char *a, **vec;
/*  similar to vdecode, but use strncmp - - no regex  */
/*ENDDOC*/
{   int match, index, len;

    match = -2;
    len = strlen (a);
    if (len == 0)
	return (match);
    for (index = 0; vec [index] != NULL; index++)
     	if (!Jstrncmp (a, vec [index], len))
	    return (index);
    return (match);
}


int vdecode (a, vec)
char *a, **vec;
{   char *re_comp ();
    int match, index;
    char stemp [200];

    sprintf (stemp, "^%s", a);

    if (re_comp (stemp) != NULL)
    {	fprintf (stderr, 
	    "PANIC - decode has invalid recomp string \"%s\"\n", 
	    stemp);
	return (-1);
    }
    match = -2;
    for (index = 0; vec [index] != NULL; index++)
    {	if (re_exec (vec [index], 0) == 1)
	{   if (match != -2)
		return (-1);
	    else
		match = index;
  	}
    }
    return (match);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

int vectorize (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, 
    q, r, s, t, u, v, w, x, y, z)
char **a, *b, *c, *d, *e, *f, *g, *h, *i, *j, *k, *l, *m, *n, *o, *p,
    *q, *r, *s, *t, *u, *v, *w, *x, *y, *z;
{   *a = b;
    a++;
    if (b == NULL)
	return;
    vectorize (a, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t,
    	u, v, w, x, y, z);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

