#ifndef LINT
static char *sccs_sid = "@(#)intro.c	2.1 3/21/89 WINLIB";
#endif

#include <stdio.h>
#include "curses.h"
#include "config.h"
#include "win-types.h"
#include "extern.h"
#include "faulkn.h"


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
alphabetize_lists ()
/*  alphabetize the function and variable lists  */
/*ENDDOC*/
{   do_alpha_ftn ();
    do_alpha_vbl ();
}

static char *nx_list [MAX_COMMANDS + MAX_VARIABLES];
static jcmp (a, b)
int *a, *b;
{   
    return (Jstrcmp (nx_list [*a], nx_list [*b]));
/*  Jstrcmp ignores case and treats ``-'' and `` '' same  */
}

/*STARTDOC*/
do_alpha_ftn ()
/*  Alphabetize the function name list (long_cmd_names) and
    adjust long_cmd_pointers and batch_cmd_pointers accordingly
*/
/*ENDDOC*/
{   int indx, len, indices [5000];
    static int (*(ptr_tmp [MAX_COMMANDS])) ();

    for (len = 0; nx_list [len] = long_cmd_names [len]; len++);
    for (indx = 0; indx <= len; indx++)
	indices [indx] = indx;
/*  do the sort  */
    qsort (indices, len, sizeof (int), jcmp);

    for (indx = 0; indx < len; indx++)
	long_cmd_names [indx] = nx_list [indices [indx]];

    bcopy (long_cmd_pointers, ptr_tmp, MAX_COMMANDS * sizeof (int *));
    for (indx = 0; indx < len; indx++)
        long_cmd_pointers [indx] = ptr_tmp [indices [indx]];
    bcopy (batch_cmd_pointers, ptr_tmp, MAX_COMMANDS * sizeof (int *));
    for (indx = 0; indx < len; indx++)
	batch_cmd_pointers [indx] = ptr_tmp [indices [indx]];
}



/*STARTDOC*/
do_alpha_vbl ()
/*  Alphabetize the variables according to variable_names,
    adjust variable_names accordingly
/*ENDDOC*/
{   int indx, len, indices [5000];
  //    static int jcmp ();
    var_node *tmp_vars [MAX_VARIABLES];

    for (len = 0; nx_list [len] = variable_names [len]; len++)
     	tmp_vars [len] = variables [len];
    for (indx = 0; indx <= len; indx++)
	indices [indx] = indx;
/*  do the sort  */
    
    qsort (indices, len, sizeof (int), jcmp);

    for (indx = 0; indx < len; indx++)
    {   variables [indx] = tmp_vars [indices [indx]];
	variable_names [indx] = variables [indx] -> name;
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
introduce_function (name, i_ftn, b_ftn, def_binding)
char *name;
int (*i_ftn) (), (*b_ftn) ();
unsigned int def_binding;
/*  introduce a function into the function handler.
    i_ftn is the interactive version, b_ftn is the batch version
    the def_binding will be installed
*/
/*ENDDOC*/
{    int where;

     where = xlsearch (name, long_cmd_names);
     long_cmd_pointers [where] = i_ftn;
     batch_cmd_pointers [where] = b_ftn;
     if (def_binding < 256)
	 short_cmd_pointers [def_binding] = i_ftn;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
var_node *introduce_variable (name, ptr, typ, hook, histry)
char *name, **histry, *ptr;
int typ, (*hook) ();
/*  Introduce a variable to the variable handler.
    name:   text name by which it is to be accessed
    ptr:    pointer to appropriate storage
    typ:    variable type from "win-types.h"
    hook:   function to run whenever variable is modified
    histry: use this storage as the history list.
		(if this is NULL, space will be allocated)
*/
/*ENDDOC*/
{   var_node *which;
    int indx, new_node;

    new_node = -1;
    which = find_var (name);
    if (!which)  /*  if it doesn't already exist, make a new one.  */
    {   for (indx = 0; variables [indx]; indx++);
        if (indx >= MAX_VARIABLES)
 	{   move (LINES - 2, 0);
     	    addstr ("Out of variable slots");
	    Pause (1);
	    return (NULL);
	}
	variables [indx] = which = 
	    (var_node *) ecalloc (1, sizeof (var_node));
	new_node = indx;
    }
    which -> strg.s = ptr;  /*  which kind not relevant - all ptrs  */
    which -> v_type = typ;
    which -> hook = hook;
    which -> name = new_string (name);
    if (new_node >= 0)
	variable_names [new_node]  = which -> name;
    if (typ)
    {   if (histry)
	    which -> history = histry;
	else
	{   which -> history = 
		(char **) ecalloc (DEF_HISTORY_LEN + 1, sizeof (char *));
	    (which -> history) [DEF_HISTORY_LEN] = (char *) -1;
	}
    }
    return (which);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

