#ifndef LINT
static char *sccs_sid = "@(#)str-cvt.c	2.1 3/21/89 FAULKNLIB";
#endif

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
unsigned char *string_convert (old, new)
unsigned char *old, *new;
/*  convert the text string ``old'' into ``binary'' string ``new''
    does ``c'' like substitutions:
	\### - substitute octal value
	\n   - new line
	\b   - back space
	\s   - space
	\M   - meta the next character
	\Z   - meta and control the next character
	^    - control the next character
*/
/*ENDDOC*/
{   unsigned char tmp;

    for (; *old; old++)
    {   switch (*old)
	{   case '\\':
		old++;
		if (!*old)
		{   old [1] = '\0';
		    break;
		}
		switch (*old)
		{   case 'n':
			*old = '\n';
			break;
		    case 'b':
			*old = '\b';
			break;
		    case 's':  /*  to prevent string breaks  */
			*old = ' ';
			break;
		    case 'f':
			*old = '\f';
			break;
		    case 'e':
			*old = '\033';
			break;
		    case 'M':
			old++;
			if (!*old)
			{   *old = 0x80;
			    old [1] = '\0';
			    break;
			}
			*old |= 0x80;
			break;
		    case 'Z':
			old++;
			if (!*old)
			{   *old = 0x80;
			    old [1] = '\0';
			    break;
			}
			*old = (*old | 0x80) & 0x9f;
			break;
		    case '0': case '1': case '2': case '3': case '4':
		    case '5': case '6': case '7': case '8': case '9':
			tmp = *old - '0';
			old++; 
			if (!*old)
			{   *old = tmp;
			    old [1] = '\0';
			    break;
			}
			if ((*old < '0') || (*old > '9'))
			{   old--;
			    *old = tmp;
			    break;
			}
			tmp = tmp * 8 + (*old - '0');
			old++;
			if (!*old)
			{   *old = tmp;
			    old [1] = '\0';
			    break;
			}
			if ((*old < '0') || (*old > '9'))
			{   old--;
			    *old = tmp;
			    break;
			}
			*old = tmp * 8 + (*old - '0');
			break;
		    default:
			break;
		}
		break;
	    case '^':
		old++;
		if (!*old)
		{   *old = '\0';
		    old [1] = '\0';
		    break;
		}
		*old &= 0x9f;
		break;
	    default:
		break;
	}
	*new = *old;
	new++;
    }
    *new = '\0';
    return (new);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

