#ifndef LINT
static char *sccs_sid = "@(#)composition.c	1.30 7/22/97 MASE ";
#endif

#include "edseq.h"
#include "extern.h"
#ifdef sparc
#include <alloca.h>
#endif
#include "../lib/faulkn.h"

int use_star = 1;

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

composition_of_column (current_y, current_x, mult)
int *current_y, *current_x, mult;
{   char stemp [300], chrx, stemp2 [200];
    int *list, *string_to_numbers (), col_num, tally [256],
	*list2, ix;
    static char *listx [20];
    sq *seq;

    listx [0] = NULL;
    win_prompt (stdscr, LINES - 2, "Composition for which sequences",
	stemp, listx, 0, "Range");
    if (!(list = string_to_numbers (stemp)))
	return;
    sprintf (stemp, "%d", *current_x + 1);
    listx [0] = stemp;
    listx [1] = NULL;
    win_prompt (stdscr, LINES - 1, "    for which column",
	stemp, listx, 0, "Comp-Which-Column"); 
    sscanf (stemp, "%d", &col_num);
    col_num--;
    clean_bottom ();
    bzero (tally, 256 * sizeof (int));
    for (list2 = list; *list2 >= 0; list2++)
    {   if (*list2)
	    seq = entry [*list2 - 1];
	else
	    seq = consensus_sequence;
	if (seq -> length >= col_num)
	    chrx = uc_char ((seq -> seq) [col_num]);
	tally [chrx]++;
    }
    move (LINES - 2, 0);
    for (ix = 'A'; ix <= 'Z'; ix++)  {
      if (tally [ix])  {
	sprintf (stemp2, "%c %d; ", ix, tally [ix]);
	addstr (stemp2);
      }
    }
    Pause (0);
    free (list);
}

sq *consensus_sequence;
float consensus_threshold = 0.0;

consensus ()
{   char which [40];
    static char *list [200] = { "1-$", NULL };

    win_prompt (stdscr, LINES - 2, "For which sequence group",
	which, list, 0, "Range");
    text_consensus (which);
}


text_consensus (which)
char *which;
{ 
    int indx, indx2, comp [256], max, *num_list, i2, count,
        num_letters;
    char *con_seq, stemp_x [400];

    con_seq = (char *) alloca (MAX_SEQ);
    if (!con_seq)
    {   move (LINES - 2, 0);
	addstr ("ERROR - cannot alloca space in text_consensus");
	Pause (1);
	return;
    }
    if (consensus_threshold < 0.0)
	consensus_threshold = 0.0;
    if (consensus_threshold > 1.0)
	consensus_threshold = 1.0;
    if (!which || !*which)
	which = "1-$";

    num_list = (int *) string_to_numbers (which);
    if (!num_list)
	return;
    indx = 0; 
    do
    {   
	bzero (comp, 256 * sizeof (int));
	num_letters = 0;
	for (indx2 = 0; (i2 = num_list [indx2]) >= 0; indx2++)
	    if (i2)  /*  consensus can't contrib to consensus  */
	    {   i2--;
	        if (indx < (entry [i2]) -> length)  {
	     	    comp [char_set [(entry [i2] -> seq) [indx]]]++;
		    num_letters++;
	        }
	    }
	max = -1;
	con_seq [indx] = '?';
	for (indx2 = ' '; indx2 <= '~'; indx2++)
	    if ((use_gaps || (indx2 != '-')) &&
		(use_star || (indx2 != '*')))
	    {   if (count = comp [indx2])
		{   if (count > max)
		    {   max = count;
			con_seq [indx] = indx2;
		    }
		    else if (count == max)
			con_seq [indx] = '?';
		}
	    }
	if ((float) max < ((float) num_letters * consensus_threshold))  {
	    con_seq [indx] = '?';
	    if (comp ['-'] == num_letters)
		con_seq [indx] = '-';
	    if (comp ['*'] == num_letters)
		con_seq [indx] = '*';
	}
	indx++;
    }   while (num_letters);
    indx--;
    con_seq [indx] = '\0';
    if (consensus_sequence -> length)
    {   free (consensus_sequence -> seq);
        free (consensus_sequence -> hlite);
    }
    else
	num_per_win--;
    consensus_sequence -> length = indx;
    consensus_sequence -> modified = 1;
    consensus_sequence -> allocated = indx + 100;
    consensus_sequence -> seq = emalloc (indx + 110);
    bcopy (con_seq, consensus_sequence -> seq, indx + 3);
    consensus_sequence -> hlite = emalloc (indx + 110);
    bzero (consensus_sequence -> hlite, indx + 100);
    sprintf (stemp_x, "%d", 300);
    sprintf (stemp_x, "; consensus sequence\n; for sequences %s\n",
	which);
    consensus_sequence -> comments = (char *) new_string (stemp_x);
    strcpy (consensus_sequence -> from_file, "Consensus-Sequence");
    strcpy (consensus_sequence -> locus_name, "CONSENSUS");
    disp_all ();
}


consensus_off ()
/*  turn off display of consensus sequence  */
{
    if (consensus_sequence -> length)
    {   free (consensus_sequence -> seq);
        free (consensus_sequence -> hlite);
	consensus_sequence -> seq = "";
	consensus_sequence -> hlite = "";
	consensus_sequence -> length = 0;
	num_per_win++;
    }
    disp_all ();
}

save_consensus ()
{   char out_name [300];

    out_name [0] = '\0';
    fsave_consensus (out_name);
}

fsave_consensus (out_name)
char *out_name;
{   FILE *outf;
    static char *hist [300];

    if (!consensus_sequence -> length)
    {   move (LINES - 2, 0);
	addstr ("No consensus generated");
	Pause (0);
	return;
    }
    outf = w_open_file (out_name, "w", hist);
    fputs (consensus_sequence -> comments, outf);
    fprintf (outf, "%s\n", consensus_sequence -> locus_name);
    write_sequence (consensus_sequence -> seq, outf);
    fclose (outf);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* (PWK) 07/22/97 */

#if 0
merge ()
/* merge one or more sequences into one - simillar to consensus */
{   char which [40];
    static char *list [200] = { "1-$", NULL };

    win_prompt (stdscr, LINES - 2, "For which sequence group",
                which, list, 0, "Range");
    text_merge (which);
}

text_merge (which)
char *which;
{ 
    int indx, indx2, comp [256], max, *num_list, i2, count,
         num_letters, ctr, del;
    char *merged_seq, stemp_x [400], *tmp;

    merged_seq = (char *) alloca (MAX_SEQ);
    if (!merged_seq)
    {   move (LINES - 2, 0);
        addstr ("ERROR - cannot alloca space in merge_consensus");
        Pause (1);
        return;
    }
    if (!which || !*which)
        which = "1-$";

    num_list = (int *) string_to_numbers (which);
    if (!num_list)
        return;
    indx = 0; 
    do
    {   
        bzero (comp, 256 * sizeof (int));
        num_letters = 0;
        for (indx2 = 0; (i2 = num_list [indx2]) >= 0; indx2++)
            if (i2)  /*  consensus can't contrib to consensus  */
            {   i2--;
                if (indx < (entry [i2]) -> length)  {
                    comp [char_set [(entry [i2] -> seq) [indx]]]++;
                    num_letters++;
                }
            }
        max = -1;
        merged_seq [indx] = '-';
        for (indx2 = ' '; indx2 <= '~'; indx2++)
            if ((indx2 != '-') && (indx2 != '*'))
            {   if (count = comp [indx2])
                {   if (count > max)
                    {   max = count;
                        merged_seq [indx] = indx2;
                    }
                    else if (count == max)
                        merged_seq [indx] = '-';
                }
            }
        if ((float) max < ((float) num_letters * consensus_threshold))  {
            merged_seq [indx] = '-';
            if (comp ['-'] == num_letters)
                merged_seq [indx] = '-';
            if (comp ['*'] == num_letters)
                merged_seq [indx] = '*';
        }
        indx++;
    }   while (num_letters);
    indx--;
    merged_seq [indx] = '\0';

    indx2 = num_list [0] - 1;
    tmp = entry [indx2];
    if (tmp -> length)
    {   free (tmp -> seq);
        if ((highlight_model - 1) == indx2)  {
            highlight_model = 0;
            if (highlight_mode == H_DIFF)  {
                highlight_mode = H_NONE;
                move (LINES - 2, 0);
                printw ("Highlight differences disabled (Model zapped)");
                Pause (0);
            }
        }
        else if ((highlight_model - 1) > indx2)
            highlight_model--;
        file_dirty (tmp -> from_file);
        free (tmp -> hlite);
    }
    else
        num_per_win--;
    tmp -> length = indx;
    tmp -> modified = 1;
    tmp -> allocated = indx + 100;
    tmp -> seq = emalloc (indx + 110);
    bcopy (merged_seq, tmp -> seq, indx + 3);
    tmp -> hlite = emalloc (indx + 110);
    bzero (tmp -> hlite, indx + 100);
    sprintf (stemp_x, "%d", 300);
    sprintf (stemp_x, "; merged sequence\n; from sequences %s\n",
             which);
    tmp_sequence -> comments = (char *) new_string (stemp_x);
    strcpy (tmp_sequence -> from_file, "Merged-Sequence");
    strcpy (tmp_sequence -> locus_name, "MERGED");

    /* from zap_sequences() */
    ctr = 0;
    for (indx2 = 1; indx2 <= num_entries; indx2++)
    {   del = 0;
        for (indx = num_list; *indx >= 0; indx++)
            if (indx2 == *indx)
                del = 1;
        if (!del)
        {   entry [ctr] = entry [indx2 - 1];
            ctr++;
        }
        else
        {   if ((highlight_model - 1) == ctr)  {
                highlight_model = 0;
                if (highlight_mode == H_DIFF)  {
                     highlight_mode = H_NONE;
                    move (LINES - 2, 0);
                    printw ("Highlight differences disabled (Model zapped)");
                    Pause (0);
                }
            }
            else if ((highlight_model - 1) > ctr)
                highlight_model--;
            file_dirty (entry [indx2 - 1] -> from_file);
        }
    }
    entry [ctr] = NULL;
    num_entries = ctr;
    
    disp_all ();
}
#endif //0

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
