#ifndef LINT
static char *sccs_sid = "@(#)display.c	1.24 3/21/89 MASE ";
#endif

#include "edseq.h"
#include "extern.h"


#include <signal.h>
#include <setjmp.h>

int highlight_mode = H_NONE, highlight_model = 0, display_alt = 0;
int inhibit_update = 0, update_pending = 0;


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

all_refresh ()
{   disp_all ();
    wrefresh (curscr);
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

plot_seq (which, where)
int which, where;
{   sq *sqtmp;
    char buf [200];

    sqtmp = entry [which];
    show_seq (seq_win_1, where, start_1, 
	sqtmp -> seq, sqtmp -> length, sqtmp -> hlite);
    show_seq (seq_win_2, where, start_2, 
	sqtmp -> seq, sqtmp -> length, sqtmp -> hlite);
    if (sqtmp -> modified)
    {   wmove (name_win, which - top_seq, 0);
	wstandout (name_win);
	sprintf (buf, "%c%4d %s", 
	    sqtmp -> new_hlite ? '*' : ' ',
	    which + 1, 
	    sqtmp -> locus_name);
	waddstr (name_win, buf);
	wstandend (name_win);
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

disp_all ()
{   int indx, numbr;
    sq *sqtmp;
    char buf [200];

    if (inhibit_update)  {
      update_pending = 1;
      return;
    }
    update_pending = 0;

    move (0, 0);
    clrtobot ();
    addstr ("Numbr Locus Name");
    move (0, 27);
    printw ("%-6d", start_1 + 1);
    move (0, 27 + seq_width - 6);
    printw ("%6d", start_1 + seq_width);
    move (0, seq_width + 28);
    printw ("%-6d", start_2 + 1);
    move (0, 28 + seq_width + seq_width - 6);
    printw ("%6d", start_2 + seq_width);

    wmove (name_win, 0, 0); wclrtobot (name_win);
    wmove (seq_win_1, 0, 0); wclrtobot (seq_win_1);
    wmove (seq_win_2, 0, 0); wclrtobot (seq_win_2);
    for (indx = 0; (indx < num_per_win) && 
         ((numbr = indx + top_seq) < num_entries); indx++)
    {   sqtmp = entry [numbr];
        wmove (name_win, indx, 0);
        sprintf (buf, "%c%4d %s", 
                 sqtmp -> new_hlite ? '*' : ' ',
                 numbr + 1,
                 sqtmp -> locus_name);
        if (sqtmp -> modified)   {
          wstandout (name_win);
          waddstr (name_win, buf);
          wstandend (name_win);
        }
        else
          waddstr (name_win, buf);
        wclrtoeol (name_win);
        show_seq (seq_win_1, indx, start_1, sqtmp -> seq, 
                  sqtmp -> length, sqtmp -> hlite);
        show_seq (seq_win_2, indx, start_2, sqtmp -> seq, 
                  sqtmp -> length, sqtmp -> hlite);
    }
    if (consensus_sequence -> length)
    {   wmove (name_win, indx, 0);
        sprintf (buf, "%5s %s", "", 
                 consensus_sequence -> locus_name);
        waddstr (name_win, buf);
        wclrtoeol (name_win);
        sqtmp = consensus_sequence;
        show_seq (seq_win_1, indx, start_1, sqtmp -> seq, 
                  sqtmp -> length, sqtmp -> hlite);
        show_seq (seq_win_2, indx, start_2, sqtmp -> seq, 
                  sqtmp -> length, sqtmp -> hlite);
        indx++;
    }
    if (prottrans_sequence -> length)
    {   wmove (name_win, indx, 0);
        sprintf (buf, "%5s %s", "", 
                 prottrans_sequence -> locus_name);
        waddstr (name_win, buf);
        wclrtoeol (name_win);
        sqtmp = prottrans_sequence;
        show_seq (seq_win_1, indx, start_1, sqtmp -> seq, 
                  sqtmp -> length, sqtmp -> hlite);
        show_seq (seq_win_2, indx, start_2, sqtmp -> seq, 
                  sqtmp -> length, sqtmp -> hlite);
        indx++;
    }
    for (; indx < num_per_win; indx++)
    {   wmove (name_win, indx, 0);
        wclrtoeol (name_win);
        wmove (seq_win_1, indx, 0);
        wclrtoeol (seq_win_1);
        wmove (seq_win_2, indx, 0);
        wclrtoeol (seq_win_2);
    }
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */


show_seq (seq_win, line, start, seq, length, hlite)
WINDOW *seq_win;
int start, length, line;
char *seq, *hlite;
{   int indx, num_to_print, this_hlite, last_hlite;
    char *model_seq;

    if (highlight_mode == H_DIFF)
    {   if (!highlight_model)
	    model_seq = consensus_sequence -> seq;
	else
	    model_seq = (entry [highlight_model - 1]) -> seq;
    }

    last_hlite = 'x';
    wmove (seq_win, line, 0);
    num_to_print = seq_width;
    indx = length - start;
    if (num_to_print > indx)
	num_to_print = indx;
    this_hlite = 0;
    last_hlite = 0;
    wstandend (seq_win);
    for (indx = 0; indx < num_to_print; indx++)
    {   switch (highlight_mode)
	{   case H_NONE:
		break;
	    case H_COLUMN:
		this_hlite = 
		    ((indx + 1 + start) % column_highlight) ?
			0 : 1;
		break;
	    case H_MASK:
		this_hlite = hlite [start + indx] - '0';
		break;
	    case H_DIFF:
		this_hlite = (char_set [seq [start + indx]] != 
		    char_set [model_seq [start + indx]]) ?
		    1 : 0;
	}
	if (this_hlite != last_hlite)
	{   last_hlite = this_hlite;
#ifdef COLOR_CURSES
	    wxstandout (seq_win, this_hlite);
#else COLOR_CURSES
#ifdef usg
	    usg_standout (seq_win, this_hlite);
#else usg
	    if (this_hlite)
		wstandout (seq_win);
	    else
		wstandend (seq_win);
#endif usg
#endif
	}
	waddch (seq_win, display_alt ? char_set [seq [start + indx]] :
            seq [start + indx]);
    }
    if (num_to_print != seq_width)
	wclrtoeol (seq_win);
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

screen_refresh ()
{   wrefresh (curscr);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   


#ifdef usg
usg_standout (win, attr)
WINDOW *win;
int attr;
{   chtype usg_attr;

    usg_attr = 0;
    if (attr & 001)
      usg_attr |= A_REVERSE;
    if (attr & 002)
      usg_attr |= A_BOLD;
    if (attr & 004)
      usg_attr |= A_UNDERLINE;
    if (attr & 010)
      usg_attr |= A_BLINK;
    wattrset (win, usg_attr);
}

#endif usg
