#ifndef LINT
static char *sccs_sid = "@(#)h-save.c	1.4 4/4/89 MASE";
#endif

#include <stdio.h>
#include "edseq.h"
#include "extern.h"


t_h_save (hfile)
char *hfile;
{   int indx, old_need;
    FILE *fout;
    sq *this;
    extern int add_one_if_needed;

/*  tell write_sequence not to append ``1''  */
    old_need = add_one_if_needed;
    add_one_if_needed = 0;

    if (!(fout = fopen (hfile, "w")))  {
	move (LINES - 2, 0);
	printw ("ERROR - could not save highlights to %s\n",
	    hfile);
	Pause (0);
	add_one_if_needed = old_need;
	return;
    }
    for (indx = 0; indx < num_entries; indx++)  {
	this = entry [indx];
        fprintf (fout, "; HIGHLIGHTS for mase\n;\n%s\n",
	    this -> locus_name);
	(this -> hlite) [this -> length] = '\0';
	write_sequence (this -> hlite, fout);
    }
    fclose (fout);
    add_one_if_needed = old_need;
}

t_h_load (hfile)
char *hfile;
{   int in_len, indx;
    char locus_name [200];
    FILE *finp;
    sq *this;

    if (!(finp = fopen (hfile, "r")))  {
	move (LINES - 2, 0);
	printw ("ERROR - could not load highlights from %s\n",
	    hfile);
	Pause (0);
	return;
    }
    for (indx = 0; indx < num_entries; indx++)  {
	this = entry [indx];
	if (!next_locus (finp, locus_name))  {
	    move (LINES - 2, 0);
	    printw ("Premature end of file on hlite file %s, aborted",
		hfile);
	    Pause (0);
	    fclose (finp);
	    return;
	}
	if (strcmp (locus_name, this -> locus_name))  {
	    move (LINES - 2, 0);
	    printw ("Expected %s, got %s - continuing, prob. bad",
		this -> locus_name, locus_name);
	    Pause (0);
	}
	in_len = 0;
	get_sequence (this -> hlite, finp, &in_len, this -> length + 10);
	if (in_len != this -> length)  {
	    move (LINES - 2, 0);
	    printw ("Bad length locus %s - might be bad", 
		this -> locus_name);
	    Pause (0);
	}
    }
    highlight_mode = H_MASK;
    disp_all ();
}

static char *history [200] = { "hlites", NULL };

h_save ()
{   char fname [200];
    
    win_prompt (stdscr, LINES - 2, "Save highlights to file", fname,
		history, 0, "HliteFile");
    t_h_save (fname);
}


h_load ()
{   char fname [200];

    win_prompt (stdscr, LINES - 2, "Load highlights from file", fname,
		history, 0, "HliteFile");
    t_h_load (fname);
}
