#ifndef LINT
static char *sccs_sid = "@(#)misc.c	2.03 6/11/97 MASE ";
#endif

#include "edseq.h"
#include "extern.h"

#include <signal.h>
#include <setjmp.h>
#include <sys/file.h>

#ifdef linux // Mike Jurka 2003
//#include <bsd/sgtty.h>
#include <linux/tty.h>
#define bsd_ioctl ioctl
#else
#include <sgtty.h>
#endif

#include <sys/ioctl.h> // Mike Jurka 2003

#include <termios.h> // Mike Jurka 2003
#include "../lib/faulkn.h"

#include "ureadseq.h" /* (PWK) */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

static char *cmd_tail_files [300];

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

bad_pipe ()
{   
    bad_pipe_write = 1;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

get_size ()
{   struct winsize buf;

    ioctl (1, TIOCGWINSZ, &buf);
    LINES = buf.ws_row;
    COLS = buf.ws_col;
}



sigwinch ()
{   int x, y;
    extern jmp_buf edit_push;

    signal (SIGWINCH, SIG_IGN);
#ifdef linux
    siginterrupt (SIGWINCH, 1);
#endif linux
    delwin (name_win);
    delwin (seq_win_1);
    delwin (seq_win_2);
#ifndef linux
    if (CE) fputs (CE, stdout);
#endif
    endwin ();
    get_size ();
    initscr ();
    noecho ();
    crmode ();
    build_subwindows ();

    longjmp (edit_push, 3);

    return;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

initialize (argv)
char **argv;
{   char stemp [200], init_file [200], *home, *getenv (), **tmp_name,
	system_rc [200];
    int bad_pipe (), indx;
    extern char *sequence_temp;
#ifndef linux
    static struct sgttyb buf;
#endif
    extern int update_pending, inhibit_update, marks_x [], marks_y [];

/*  initialize marks so we know if they haven't been set  */
    for (indx = 0; indx <= 100; indx++)
	marks_x [indx] = marks_y [indx] = -1;
    inhibit_update = 1;
#ifndef linux
    ioctl (0, TIOCGETP, &buf);
    buf.sg_flags &= (~CRMOD & ~XTABS);
    ioctl (0, TIOCSETP, &buf);
#endif
    lnfac_init ();  /*  initialize the lnfac tables  */
    entry = (sq **) ecalloc (NUMBER_SEQ, sizeof (sq *));
    score_matrix = (float **) ecalloc (128, sizeof (float *));
    default_matrix ();
    default_char_set ();
 
    signal (SIGINT, quit);
    signal (SIGPIPE, bad_pipe);
#ifdef linux
    siginterrupt (SIGINT, 1);
    siginterrupt (SIGPIPE, 1);
#endif linux
    noecho ();
    crmode ();

    fflush (stdout);
    if ((LINES < 10) || (COLS < 50))
    {   endwin ();
	fprintf (stderr, "\nSorry, \"%s\" will not work with fewer\n",
	    prog_name);
	fprintf (stderr, "    than 10 lines or fewer than 50 columns\n");
	exit (1);
    }

    hello ();

    command_tail (argv);
    scrollok (stdscr, 2);
    scrollok (curscr, 2);
    build_subwindows ();
     
    if (*cmd_tail_files)    /*  read in the established file list cmd tail */
        for (tmp_name = cmd_tail_files; *tmp_name; tmp_name++)
	{   clean_bottom ();
	    read_file (*tmp_name);
        }

    sprintf (system_rc, "%sMaserc", mase_dir);
    if (!access (system_rc, R_OK))
    {   clean_bottom ();
	source_file (system_rc);
    }
    if (home = getenv ("HOME"))
    {   getcwd (stemp, 0);
	if (strcmp (stemp, home) != 0)
	/*  don't source home if already there  */
	{   sprintf (init_file, "%s/.%src", home, prog_name);
	    if (!access (init_file, R_OK))
            {   clean_bottom ();
		source_file (init_file);
	    }
	}
    }
    sprintf (init_file, ".%src", prog_name);
    if (!access (init_file, R_OK))
    {   clean_bottom ();
	source_file (init_file);
    }
/*  clean bottom after source files  */
    clean_bottom ();
    refresh ();
    start_1 = 0;
    start_2 = seq_width;

    set_file_list ();
    while (!num_entries)
    {   clean_bottom ();
	create_or_load ();
    }
    
    inhibit_update = 0;
    if (update_pending)
      disp_all ();
    clean_bottom ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

set_file_list ()
{   char stemp [200], **sptr;
    FILE *ls_pipe;

    sptr = file_list = (char **) ecalloc (200, sizeof (char *));
    *sptr = "NONE";
    sptr++;
    sprintf (stemp, "/bin/ls %s | /bin/sed -e \'s~^~=/~\'",
	MASE_FILES_DIR);
    if (ls_pipe = popen (stemp, "r"))
    {   do
	{   *stemp = '\0';
	    fscanf (ls_pipe, "%s", stemp);
	    if (*stemp)
	    {   *sptr = (char *) new_string (stemp);
		sptr++;
	    }
	}   while (*stemp);
    }
    pclose (ls_pipe);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

static jmp_buf hello_push;

hello_abort ()
{   longjmp (hello_push, 2);
}

hello ()
{   
    extern char Release [];
    int hello_abort ();

    if (fast)
	return;
    if (setjmp (hello_push))
    {	/*  wclear (t);
	delwin (t);  */
	wclear (stdscr);
	alarm (0);
	signal (SIGALRM, SIG_DFL);
	signal (SIGINT, quit);
#ifdef linux
	siginterrupt (SIGALRM, 1);
 	siginterrupt (SIGINT, 1);
#endif linux
	return;
    }

    signal (SIGALRM, hello_abort);
    signal (SIGINT, hello_abort);
#ifdef linux
	siginterrupt (SIGALRM, 1);
 	siginterrupt (SIGINT, 1);
#endif linux
    box (stdscr, '*', '*');
    move (2,4);
    standout ();
    addstr (" M ");
    standend ();
    addstr (" ultiple");

    move (3,5);
    standout ();
    addstr (" A ");
    standend ();
    addstr (" ligned");

    move (4,6);
    standout ();
    addstr (" S ");
    standend ();
    addstr (" equence");

    move (5,7);
    standout ();
    addstr (" E ");
    standend ();
    addstr (" ditor");

    move (7,4);
    addstr ("The MBCRR at The Dana-Farber Cancer Institute");
    move (8,4);
    addstr ("    and The Harvard School of Public Health");
    move (9,4);
    addstr ("D.V. Faulkner and J. Jurka");
    move (11,4);
    addstr (Release);
    move (13,4);
    addstr ("Regular expression handler from GNU-EMACS");
    move (14, 6);
    addstr ("Copyright (C) 1985 Free Software Foundation, Inc.");
    move (LINES - 1, COLS - 1);

    move (16, 4);
    addstr ("Published: Multiple Aligned Sequence Editor (MASE)");
    move (17, 6);
    addstr ("Donald V. Faulkner And Jerzy Jurka");
    move (18, 6);
    addstr ("TIBS, Vol.13, Pages 321-322, 1988");
    refresh ();
    alarm (4);

    getchar ();
    alarm (0);

    wclear (stdscr);
    signal (SIGALRM, SIG_DFL);
    signal (SIGINT, quit);
#ifdef linux
    siginterrupt (SIGALRM, 1);
    siginterrupt (SIGINT, 1);
#endif linux
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

build_subwindows ()
{   
#ifdef linux
    extern WINDOW **refresh_list;
#endif

    num_per_win = LINES - 1 - 2;  /*  1 at top, 2 at bot  */
    name_win = subwin (stdscr, num_per_win, 26, 1, 0);

    seq_width = COLS - 3 - 26;  /*  two spaces and locus and
				    two so it doesn't wrap  */
    seq_width /= 2;
    seq_win_1 = subwin (stdscr, num_per_win, seq_width, 1, 27);
    seq_win_2 = subwin (stdscr, num_per_win, seq_width, 1, 
	28 + seq_width);
#ifdef linux
    refresh_list = (WINDOW **) ecalloc (5, sizeof (WINDOW *));
    refresh_list [0] = name_win;
    refresh_list [1] = seq_win_1;
    refresh_list [2] = seq_win_2;
    refresh_list [3] = NULL;
#endif
    
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

read_file (fname)
char *fname;
/*  read in all loci from fname  */
{   FILE *finp;
    int state;
    sq *tmp, *rd_next ();
    char stemp [200];

 /* (PWK)+ */
    short format, err, nseq, atseq;
    long seqlen, skiplines, idx;
    char *seq, *seqlist, seqid[256];
    FILE *fout;
    char foutname[200];
 /* (PWK)- */

    if (!*fname)
	return 0;

    move (LINES - 2, 0);
    state = 0;
    if (!new_file (fname))
    {   addstr ("File \"");
	addstr (fname);
	addstr ("\" already read");
	Pause (0);
	return (1);
    }

    if ((finp = fopen (fname, "r")) == NULL)
    {   addstr ("ERROR - could not read file \"");
	addstr (fname);
	addstr ("\"");
	Pause (0);
	state = 1;
    }   else
    { /* (PWK) */
/* (PWK)+ */
      format = seqFileFormat(fname, &skiplines, &err);
      if (format != kIG)
      {
	  addstr ("Converting \"");
	  addstr (fname);
	  addstr ("\"");
	  clrtoeol ();
	  refresh ();
	  sprintf(foutname, "%s.ig", fname);
	  if (format == kBLAST)
	    BLASTtoIG(fname, foutname);
	  else if (format == kCENSOR)
	    CENSORtoIG(fname, foutname);
	  else {
	    fout = fopen(foutname, "w");
	    if (err == 0)
	      seqlist = listSeqs(fname, skiplines, format, &nseq, &err);
	    for (idx = 1; idx <= nseq; idx++) {
	      seq = readSeq(idx, fname, skiplines, format,
			    &seqlen, &atseq, &err, seqid);
	      writeSeq(fout, seq, seqlen, kIG, seqid);
	    }
	    fclose(fout);
	  }
	  fname = foutname;
	  fclose(finp);
	  finp = fopen (fname, "r");
      }
/* (PWK)- */
      addstr ("Reading \"");
      addstr (fname);
      addstr ("\"");
      clrtoeol ();
      refresh ();

      while (tmp = rd_next (finp))
      {   strcpy (tmp -> from_file, fname);
	  if (!silent)
	  {   move (LINES - 2, 40);
	      sprintf (stemp, "\"%-20s\", %7d", tmp -> locus_name,
		       tmp -> length);
	      addstr (stemp);
	      clrtoeol ();
	      refresh ();
	  }
	  entry [num_entries] = tmp;
	  num_entries++;
      }
      state = 0;
    } /* (PWK) */

    if (state == 0)
	fclose (finp);
    return (state);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

sq *rd_next (finp)
FILE *finp;
{   sq *tmp;
    char *stemp, *sptr, *sptr2;
    int max_char, filpos, working, len, indx, to_allocate;

    if (feof (finp))
	return (0);
    tmp = (sq *) ecalloc (1, sizeof (sq));

    if (MAX_COMMENTS > MAX_SEQ)
	max_char = MAX_COMMENTS;
    else
	max_char = MAX_SEQ;

    sptr = stemp = emalloc (max_char + 100);
/*  read in the comments  */
    len = 0;
    do
    {   if (!fgets (sptr, 100, finp))
	{   move (LINES - 1, 0);
	    addstr ("No sequence before EOF");
	    free (stemp);
	    return (0);
	}
	len += strlen (sptr);
	if (len < (MAX_COMMENTS))
	    if (*sptr == ';')
		while (*sptr)
		    sptr++;
    }   while ((*sptr == '\0') || (*sptr == ';') || (*sptr == 0xc));
/*  fall through when sptr points to locus name  */
    blstrip (sptr);
    sptr [19] = '\0';
    strcpy (tmp -> locus_name, sptr);
    for (sptr2 = tmp -> locus_name; *sptr2; sptr2++)
	if (*sptr2 == '\n')
	    *sptr2 = '\0';
    *sptr = '\0';
    tmp -> comments = emalloc (len + 5000);
    bcopy (stemp, tmp -> comments, len);
/*  read in the sequence  */

    working = 1;
    sptr = stemp;
    len = 0;
    do
    {   filpos = ftell (finp);
	if ((working = (int) fgets (sptr, 100, finp)))
	{   if ((*sptr == ';') || (*sptr == 0xc))
	    {   working = 0;
		fseek (finp, filpos, 0);
	    }
	    else
		for (sptr2 = sptr; *sptr2; sptr2++)
		/* {   if (*sptr2 > ' ') */ /* (PWK) 08/07/96 */
		{   if (*sptr2 > ' ' && *sptr2 != '1')
		    {   *sptr = *sptr2;
			sptr++;
			len++;
		    }
		}
	}
    }   while (working);

    tmp -> length = len;
    *sptr = '\0';
    tmp -> allocated = to_allocate = len + 200;
    tmp -> seq = emalloc (to_allocate);
    strcpy (tmp -> seq, stemp);
    free (stemp);
    stemp = tmp -> hlite = emalloc (to_allocate);

    for (indx = 0; indx < (len + 100); indx++)
	stemp [indx] = '0';
    return (tmp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

/* (PWK - 06/11/97) */
sq *rd_next_add_anchors (finp)
FILE *finp;
{   sq *tmp;
    char *stemp, *sptr, *sptr2;
    int max_char, filpos, working, len, indx, to_allocate;

    if (feof (finp))
      return (0);
    tmp = (sq *) ecalloc (1, sizeof (sq));

    if (MAX_COMMENTS > MAX_SEQ)
      max_char = MAX_COMMENTS;
    else
      max_char = MAX_SEQ;

    sptr = stemp = emalloc (max_char + 100);
/*  read in the comments  */
    len = 0;
    do
    {   if (!fgets (sptr, 100, finp))
        {   move (LINES - 1, 0);
            addstr ("No sequence before EOF");
            free (stemp);
            return (0);
        }
        len += strlen (sptr);
        if (len < (MAX_COMMENTS))
          if (*sptr == ';')
            while (*sptr)
              sptr++;
    }   while ((*sptr == '\0') || (*sptr == ';') || (*sptr == 0xc));
/*  fall through when sptr points to locus name  */
    blstrip (sptr);
    sptr [19] = '\0';
    strcpy (tmp -> locus_name, sptr);
    for (sptr2 = tmp -> locus_name; *sptr2; sptr2++)
      if (*sptr2 == '\n')
        *sptr2 = '\0';
    *sptr = '\0';
    tmp -> comments = emalloc (len + 5000);
    bcopy (stemp, tmp -> comments, len);
/*  read in the sequence  */

    working = 1;
    sptr = stemp;
    len = 0;
    do
    {   filpos = ftell (finp);
        if ((working = (int) fgets (sptr, 100, finp)))
           {   if ((*sptr == ';') || (*sptr == 0xc))
               {   working = 0;
                   fseek (finp, filpos, 0);
               }
               else
                   for (sptr2 = sptr; *sptr2; sptr2++)
                   /* {   if (*sptr2 > ' ') */ /* (PWK) 08/07/96 */
                   {   if (*sptr2 > ' ' && *sptr2 != '1')
                       {   *sptr = *sptr2;
                           sptr++;
                           len++;
                       }
                   }
           }
    }   while (working);

    tmp -> length = len;
    *sptr = '\0';
    tmp -> allocated = to_allocate = len + 200;
    tmp -> seq = emalloc (to_allocate);

    /* used for "restricted" alignment: add anchors: */
    strcpy (tmp -> seq, ".");
    strcat (tmp -> seq, stemp);
    strcat (tmp -> seq, ".");
    free (stemp);
    stemp = tmp -> hlite = emalloc (to_allocate);

    for (indx = 0; indx < (len + 100); indx++)
      stemp [indx] = '0';
    return (tmp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

command_tail (argv)
char **argv;
{   char **ftemp, *sptr;

    prog_name = *argv;
    for (sptr = prog_name; *sptr; sptr++)
	if (*sptr == '/')
	    prog_name = sptr + 1;

    ftemp = cmd_tail_files;
    var_initialize (argv);
    clean_bottom ();
    for (argv++; *argv; argv++)
    /*  process command tail  */
    {   if (**argv == '-')
	{   (*argv)++;
	    switch (**argv)
	    {   case 'x':
		    argv++;
		    if (*argv)
			sscanf (*argv, "%d", &COLS);
		    break;
	        case 'y':
		    argv++;
		    if (*argv)
			sscanf (*argv, "%d", &LINES);
		    break;
		case 'f':
		    argv++;
		    if (*argv)
		      interpret_line (*argv);
		    break;
		case 's':
		    silent = 1;
		    break;
	    }
	}
	else
	{   *ftemp = *argv;
	    ftemp++;
	}
    }
    *ftemp = NULL;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

quit ()
{   static char *list [] = { "YES", "NO", NULL };
    char uc_char (), in_char;

#ifdef linux
    signal (SIGINT, quit);
    siginterrupt (SIGINT, 1);
#endif

    do_map ('Y', NULL);
    do_map ('y', NULL);
    do_map ('n', NULL);
    do_map ('N', NULL);
    do_map ('\n', NULL);
    do_map ('\r', NULL);

/*    unmap ();  */
    if (mark_dirty_files (NULL))
    {   move (LINES - 2, 0);
	addstr ("Some buffers modified - - ");
	clrtoeol ();
	if (!win_prompt (stdscr, LINES - 1, 
	    "    Save them", NULL, list, 1, "save/"))
	    save ();
	else
	{   move (LINES - 1, 0);
	    addstr ("Some work lost");
	    clrtoeol ();
	    wrefresh (stdscr);
	}
    }

    clean_bottom ();
    move (LINES - 2, 0);
    addstr ("Really exit mase? (Y or N) -> ");
    refresh ();
    do
    {   in_char = uc_char (getchar ());
    }   while ((in_char != 'Y') && (in_char != 'N'));

    if (in_char == 'N')
    {   clean_bottom ();
	move (LINES - 1, 0);
	addstr ("Mase Resumed (Hit <CR> if no response).");
	refresh ();
	return;
    }
    mvcur (0, COLS -1,  LINES - 1, 0);
    endwin ();
    putchar ('\n');
    exit (0);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

new_file (name)
char *name;
/*  register that file name is active - it has been read in  */
/*  return true if it is a new file name  */
{   int match, indx;

    match = 1;

    for (indx = 0; (file_names [indx]) && ((match = 
	strcmp (file_names [indx], name)) != 0); indx++);
    
    if (match != 0)
    {   file_names [indx] = (char *) new_string (name);
	file_names [indx + 1] = NULL;
	dirty_files [indx] = '0';
	return (1);
    }
    else return (0);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

file_dirty (name)
char *name;
/*  mark file name as dirty  */
{   int indx;

    for (indx = 0; (file_names [indx] != NULL) &&
	(strcmp (file_names [indx], name) != 0); indx++);
    if (file_names [indx] == NULL)
	file_names [indx] = (char *) new_string (name);
    dirty_files [indx] = '1';
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

int *string_to_numbers (str)
/*  converts a string into a list of numbers
    returns either a 0 terminated list or NULL if bad string
    ``$'' means ``number of sequences''
*/
char *str;
#define MAX_NUMBERS 2000
{   int tmp [MAX_NUMBERS], num_found, wkg_1, wkg_2, state, *ptr,
	indx, itmp;
    char stemp [200];

    state = 0;
    wkg_1 = wkg_2 = -1;

    strcat (str, " ");  /*  tie it off trick  */

    for (num_found = 0; *str; str++)
    {   switch (*str)
	{   case ' ':
	    case '\n':
	    case ',':  /*  terminate a single one  */
		if (wkg_1 == -1)
		    break;
		if (state)  /*  it is terminating a range  */
		{   for (indx = wkg_2; indx <= wkg_1; indx++)
		    {   tmp [num_found] = indx;
			num_found++;
			if (num_found >= MAX_NUMBERS)
			{   move (LINES - 2, 0);
			    printw ("More than %d numbers in list",
				MAX_NUMBERS);
			    Pause (0);
			    return (NULL);
			}
		    }
		}
		else   /*  it is terminating a single  */
		{   tmp [num_found] = wkg_1;
		    num_found++;
		    if (num_found >= MAX_NUMBERS)
		    {   move (LINES - 2, 0);
			printw ("More than %d numbers in list", MAX_NUMBERS);
			Pause (0);
			return (NULL);
		    }
		}
		state = 0;
		wkg_1 = -1;
		break;
	    case '-':
		if (wkg_1 == -1)
		    return (NULL);
		wkg_2 = wkg_1;
		wkg_1 = -1;
		state = 1;
		break;
	    case '0': case '1': case '2': case '3': case '4':
	    case '5': case '6': case '7': case '8': case '9':
		if (wkg_1 == -1)
		    wkg_1 = 0;
		wkg_1 = wkg_1 * 10 + *str - '0';
		break;
	    case '$':
		wkg_1 = num_entries;
		break;
	    default:
		move (LINES - 2, 0);
		printw ("Invalid character 0x%x in number string",
		    (int ) *str);
	        Pause (0);
		return (NULL);
	}
    }
    ptr = (int *) ecalloc (num_found + 2, sizeof (int));
    for (indx = 0; indx < num_found; indx++)
    {   itmp = tmp [indx];
    	if ((itmp < 0) || (itmp > num_entries))
	{   free (ptr);
	    move (LINES - 2, 0);
	    sprintf (stemp, "Number %d out of range, must be 1-%d", itmp,
		num_entries);
	    addstr (stemp);
	    Pause (0);
	    return (NULL);
	}
	ptr [indx] = itmp;
    }
    ptr [num_found] = -1;  /*  terminate it  */
    return (ptr);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

