#ifndef LINT
static char *sccs_sid = "@(#)output.c	1.38 4/4/89 MASE ";
#endif

#include "edseq.h"
#include "extern.h"
#include "../lib/faulkn.h"


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

static char label_size = 0;

#define BY_PATTERN 0
#define BY_LETTERS 1
#define BY_DIFFERENCES 2

int ff_output = 1;
int suppress_locus_numbers;

do_output ()
/*  write output to file or stream  */
{   static char *out_names [2000];
    static char *style_menu [] = { "BY-PATTERN",
	"BY-LETTERS", "BY-DIFFERENCES", NULL };
    char fname [200], cfg_name [200], stemp [200],
	*str [128], *seq, *sptr, name_format [30], *hlite, 
	state, *model_seq;
    int longest_seq, indx, indx2, indx3,
	length, itemp, longest_locus_name, page_major, page_minor,
	line_number, style, this_state;
    FILE *fcfg, *fout;

    fix_page_param ();

    longest_locus_name = 0;
    if (label_each_page)
    {	for (indx = 0; indx < num_entries; indx++)
	{   longest_locus_name = (longest_locus_name < 
		(itemp = strlen (entry [indx] -> locus_name)) ?
		itemp : longest_locus_name);
	}
	if (suppress_locus_numbers)
	    sprintf (name_format, "%c-%ds ", '%', 
		longest_locus_name);
	else
	    sprintf (name_format, "%c5d %c-%ds ", '%', '%', 
		longest_locus_name);
	label_size = 5 + 1 + longest_locus_name + 1;
    }
    else
	label_size = 0;

    for (indx = 0; indx < 128; indx++)
	str [indx] = NULL;

    do
    {   win_prompt (stdscr, LINES - 2, 
	    "File containing string mappings", stemp, file_list, 0,
	    "Out-Strings-File");
	if (!*stemp)
	    return;
	if (*stemp == '=')
	    sprintf (cfg_name, "%s%s", MASE_FILES_DIR, &(stemp [1]));
	else
	    strcpy (cfg_name, stemp);
	uc_string (stemp);
	if (strcmp (stemp, "NONE"))
	{   fcfg = w_open_file (cfg_name, "r", file_list);
	    if (!fcfg)
	    {   move (LINES - 2, 0);
		printw ("Could not read from \"%s\"\n", cfg_name);
		Pause (0);
	    }
	    else
	    {	read_strs (fcfg, str);
		fclose (fcfg);
	    }
	}
    }   while (!fcfg && strcmp (stemp, "NONE"));

    style = win_prompt (stdscr, LINES - 2, "Map colors",
	(char *) NULL, style_menu, 1, "output/");
    if (style == BY_DIFFERENCES)  {
      if (highlight_model)
	model_seq = entry [highlight_model - 1] -> seq;
      else
	model_seq = consensus_sequence -> seq;
    }
    do
    {   win_prompt (stdscr, LINES - 2, "Output file",
	    fname, out_names, 0, "Out-Outfile");
	if (!*fname)
	    return;
	fout = w_open_file (fname, "w", out_names);
	if (!fout)
	{   move (LINES - 2, 0);
	    printw ("Could not write to \"%s\"", fname);
	    Pause (0);
	}
    }   while (!fout);

    longest_seq = 0;
    for (indx = 0; indx < num_entries; indx++)
        if ((indx2 = entry [indx] -> length) > longest_seq)
	    longest_seq = indx2;
   
    if (str [' '])
	fputs (str [' '], fout);
    fprintf (fout, "\n\n");
    if (!label_each_page)
    {	for (indx = 0; indx < num_entries; indx++)
	{   if (page_length && (!(indx % page_length)) && indx)
	    {   if (ff_output)
		    fputs ("\f", fout);
		fprintf (fout, "\n\n");
	    }
	    fprintf (fout, "%5d %s\n", indx + 1,
		entry [indx] -> locus_name);
	}
	if (ff_output)
	    fputs ("\f", fout);
        fprintf (fout, "\n\n");
    }

    page_major = 0;
    for (indx = 0; indx < longest_seq; indx += bases_per_page)
    {	page_major++; page_minor = 1; line_number = -1;
	for (indx2 = 0; indx2 < num_entries; indx2++)
	{   line_number++;
	    if ((line_number == page_length) || (!indx2))
	    {   if ((page_major < 10) || (page_minor == 1))
		{   move (LINES - 1, 0);
		    printw ("Page %3d", page_major);
		    if (page_major < 10)
			printw (".%2d", page_minor);
		    clrtoeol ();
		    refresh ();
		}
		if (indx2)
		{   if (ff_output)
			fputs ("\f", fout);
		    fputs ("\n\n", fout);
		}
		fprintf (fout, "Page %d.%d\n", page_major, page_minor);
		page_headers (fout, indx);
		line_number = 1;
		page_minor++;
	    }
	    if (skip_lines && line_number && 
		!(line_number % skip_lines))
	    {   fprintf (fout, "\n");
		line_number++;
	    }
	    if (label_each_page)
		if (suppress_locus_numbers)
		    fprintf (fout, name_format,
			entry [indx2] -> locus_name);
		else
		    fprintf (fout, name_format, indx2 + 1,
			entry [indx2] -> locus_name);
	    seq = entry [indx2] -> seq;
	    hlite = entry [indx2] -> hlite;
	    length = entry [indx2] -> length;
	    if (str [' '])
		fputs (str [' '], fout);
	    state = ' ';
	    for (indx3 = indx; (indx3 < indx + bases_per_page) &&
		(indx3 < length); indx3++)
	    {   if (bases_per_column && 
		    !((indx3) % bases_per_column) && (indx3 - indx))
		{   if (str [' '])
			fputs (str [' '], fout);
		    putc (' ', fout); 
		    state = ' ';
		}
		if (style == BY_LETTERS)
		{   if (sptr = str [seq [indx3]])
			fputs (sptr, fout);
		    else
		    {   if (str [' '])
			    fputs (str [' '], fout);
			putc (seq [indx3], fout);
		    }
		}
		else
		{   if (style == BY_PATTERN)
		      this_state = hlite [indx3];
		    else
		      this_state = (char_set [seq [indx3]] ==
				    char_set [model_seq [indx3]]) ?
			'0' : '1';
		    if (state == this_state)
			putc (seq [indx3], fout);
		    else
		    {   state = this_state;
			if (str [state])
			    fputs (str [state], fout);
			putc (seq [indx3], fout);
		    }
		}
	    }
	    if (str [' '])
		fputs (str [' '], fout);
	    state = ' ';
	    if (output_position && 
		((itemp = count_base (indx2, indx3 - 1)) != -1))
		fprintf (fout, " %6d", itemp);
	    putc ('\n', fout);
	}
	if (ff_output)
	    fputs ("\f", fout);
	fputs ("\n\n", fout);
    }

    for (indx = 0; indx < 128; indx++)
	if (sptr = str [indx])
	    free (stemp);

    fclose (fout);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

fix_page_param ()
/*  twitch the parameters for the pagination of output  */
{   int new_bases_per_page;

    if (bases_per_page < 10)
    {   parm_er ("Bases-per-page %d, less than 10, set to 50",
	    bases_per_page);
	bases_per_page = 50;
    }
    if (bases_per_page > 200)
    {   parm_er ("Bases-per-page %d, greater than 200, set to 50",
	    bases_per_page);
	bases_per_page = 200;
    }
    if (bases_per_column && bases_per_page / bases_per_column < 2)
    {   parm_er (
	    "Bases-per-column %d, less than 2 cols per page, set to 0",
	    bases_per_column);
	bases_per_column = 0;
    }
    if (bases_per_column)
    {   new_bases_per_page = 
	    bases_per_page - (bases_per_page % bases_per_column);
	if (new_bases_per_page != bases_per_page)
	{   parm_er ("Bases-per-page rounded to %d", 
		new_bases_per_page);
	    bases_per_page = new_bases_per_page;
	}
    }
    if (skip_lines < 0)
    {   parm_er ("Skip lines %d, less than 0, set to 0", skip_lines);
	skip_lines = 0;
    }
    if (skip_lines == 1)
	skip_lines = 2;

    if (page_length < 0)
    {   parm_er ("Page length %d, less than 0, set to 0", page_length);
	page_length = 0;
    }
    else if (page_length < 5)
    {   parm_er ("Page length %d, less than 5, set to 5", page_length);
	page_length = 5;
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

page_headers (fout, ofst)
FILE *fout;
int ofst;
{   int indx, indx2;

    if (label_each_page)
	for (indx = 0; indx < label_size; indx++)
	    putc (' ', fout);
   
    if (bases_per_column)  /*  there are columns  */
    {   for (indx = 0; indx < bases_per_page; indx +=
	    bases_per_column)
	{   fprintf (fout, "%-6d", ofst + 1 + indx);
	    if (bases_per_column > 12)
	    {   for (indx2 = bases_per_column - 12; indx2; indx2--)
		    putc (' ', fout);
		fprintf (fout, "%6d", ofst + indx +
		    bases_per_column);
	    }
	    else
	    {   for (indx2 = bases_per_column - 6; indx2; indx2--)
		    putc (' ', fout);
	    }
	    putc (' ', fout);
	}
    }
    else  /*  no columns  */ 
    {   fprintf (fout, "%-6d", ofst + 1);
	for (indx2 = bases_per_page - 12; indx2; indx2--)
	    putc (' ', fout);
	fprintf (fout, "%6d", ofst + bases_per_page);
    }
    putc ('\n', fout);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

read_strs (fil, str)
FILE *fil;
char *str [128];
{   char stemp2 [200], stemp [200], *sptr, *sptr2, *new_string ();

    sptr = stemp;
    sptr++;

    while (fgets (stemp2, 199, fil))
    {   string_convert (stemp2, stemp);
	if ((*stemp != '\t') && (*stemp != '\n') && (*stemp != '\0'))
	{   for (sptr2 = stemp; *sptr2; sptr2++)
		if (*sptr2 == '\n')
		    *sptr2 = '\0';
	    str [*stemp] = new_string (sptr);
	}
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

parm_er (str, ix)
char *str;
int ix;
{   move (LINES - 2, 0);
    printw (str, ix);
    Pause (0);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

