#ifndef LINT
static char *sccs_sid = "%W% %G% MASE ";
#endif

#include "edseq.h"
#include "extern.h"
#include "../lib/regex.h"
#include "../lib/faulkn.h"
#include <alloca.h>


int ignore_gaps = 0, hlite_ignore_gaps = 0;


int ignore_case = 1, default_hlite = 1;
char pat_let = '1';
int dfl_clear_pats = 0, pat_ask_clear = 1;
char *hmm_history [] = {"SET", "AND", "OR", "ADD", NULL, NULL, NULL };
int hmm = 0;
char hlite_merge_method [200] = "SET";

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

def_h_verify ()
{   if (default_hlite <= 0)
	default_hlite = 1;
    if (default_hlite > 9)
	default_hlite = 9;
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

hmm_verify ()
{   int indx;

    /* (PWK) 08/15/96 was indx = 3 */
    for (indx = 4; hmm_history [indx]; indx++)  {
	free (hmm_history [indx]);
	hmm_history [indx] = NULL;
    }
    switch (hmm = svdecode (hlite_merge_method, hmm_history))  {
	case 0:
	case 1:
	case 2:
	case 3:
	    break;
	default:
	    hmm = win_prompt (stdscr, LINES - 2, 
		"Highlight Merge Method",
		hlite_merge_method, hmm_history, 1, "HMM/");
	    break;
    }
    strcpy (hlite_merge_method, hmm_history [hmm]);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

xhlite (x, y, num, color)
int x, y, num, color;
{   char *stemp;
    int indx, l;

    if (x < 0)
	return 0;
    if (num < 0)  {
	return (xhlite (x + num, y, -1 * num, color));
    }
    stemp = &((entry [y] -> hlite) [x]);
    l = entry [y] -> length;
    if (num + x > l)  {
	if (num > l)
	    return 0;
	num = l - x;
    }
    switch (hmm)  {
	case 0:
	    for (indx = 0; indx < num; indx++, stemp++)
		*stemp = (color + '0');
   	    break;
	case 1:
	    for (indx = 0; indx < num; indx++, stemp++)
		*stemp &= (color + '0');
   	    break;
	case 2:
	    for (indx = 0; indx < num; indx++, stemp++)
		*stemp |= (color + '0');
   	    break;
	case 3:
	    for (indx = 0; indx < num; indx++, stemp++)
		*stemp += color;
   	    break;
    }
    return 0;
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

highlight_position (current_y, current_x, mult)
int *current_x, *current_y, mult;
{   
    xhlite (*current_x, *current_y, mult, default_hlite);
    highlight_mode = H_MASK;
    disp_all ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

un_highlight_position (current_y, current_x, mult)
int *current_x, *current_y, mult;
{   int old_hmm;

    old_hmm = hmm;
    hmm = 0;
    xhlite (*current_x, *current_y, mult, 0);
    hmm = old_hmm;
    highlight_mode = H_MASK;
    disp_all ();
}



/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

static char *pattern_history [400];

t_pattern_highlight (colr, pat)
char *colr, *pat;
{   int icolor;
    char **ptr, *new_string ();

    if (*pat) {   /*  then have pat and number  */
      sscanf (colr, "%d", &icolor);
    }
    else  {
      pat = colr;
      icolor = 1;
    }
    if (icolor < 0)
      icolor = 1;
    else if (icolor >= 10)
      icolor = 9;
    for (ptr = pattern_history; *ptr; ptr++);
    if (ptr > pattern_history)  {
	if (strcmp (ptr - 1, pat))
	    *ptr = new_string (pat);
    }
    else
	*ptr = new_string (pat);
    ptr++;
    *ptr = NULL;
    pat_let = icolor + '0';
    do_highlighting (pat);
}


pattern_highlight (current_y, current_x, mult)
int *current_x, *current_y, mult;
{   char patn [200];
    static char *yes_no_yes [3] = { "YES", "NO", NULL },
      *yes_no_no [3] = { "NO", "YES", NULL };
    int response;

    if (mult <= 0)
	mult = 1;
    if (mult > 9)
	mult = 9;
    pat_let = mult + '0';
    column_highlight = 0;
    if (pat_ask_clear)   {
      response = win_prompt (stdscr, LINES - 2, "Clear old highlights",
		       (char *) NULL,
		       dfl_clear_pats ? yes_no_yes : yes_no_no,
		       1, "Patterns/");
      if (response ^ dfl_clear_pats)
	clear_hlites ();
    }
    else if (dfl_clear_pats)
      clear_hlites ();

    win_prompt (stdscr, LINES - 2, "Pattern to highlight",
	patn, pattern_history, 0, "Pat-Hlite");
    do_highlighting (patn);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

do_clear_hlites ()
{   clear_hlites ();
    disp_all ();
}

clear_hlites ()
{   char *stemp;
    int indx, indx2, len;

    for (indx = 0; indx < num_entries; indx++)
    {   stemp = entry [indx] -> hlite;
	len =  entry [indx] -> length;
	for (indx2 = 0; indx2 <= len; indx2++)
	    stemp [indx2] = '0';
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   


do_highlighting (patn)
char *patn;
{   char *seq, *hlite, *re_rtn, parsed [2000], *tseq, *thlite,
      *o_seq, *n_seq, *o_hlite, *n_hlite;
    int indx, indx2, len, istart, hits;
    struct re_pattern_buffer re_buf;
    struct re_registers re_regs;

    tseq = thlite = NULL;
    if (!*patn)
	return;

    re_buf.allocated = 200;
    re_buf.buffer = emalloc (200);
    re_buf.fastmap = emalloc (2200);
    if (ignore_case)
	re_buf.translate = re_ignorecase;
    else
	re_buf.translate = re_case;
    if (ignore_gaps)  {
      thlite = (char *) alloca (MAX_SEQ);
      tseq = (char *) alloca (MAX_SEQ);
      if (!thlite || !tseq)   {
	move (LINES - 2, 0);
	addstr ("Could not allocate the space to ignore gaps");
	Pause (0);
	move (LINES - 2, 0);
	addstr ("Highlighting not done");
	Pause (0);
	return;
      }
    }
    re_rtn = re_parse (patn, parsed);
    if (re_rtn)
    {   move (LINES - 2, 0);
	printw ("Bad regexp: \"%s\"", re_rtn);
	Pause (0);
        free (re_buf.buffer);
	free (re_buf.fastmap);
	return;
    }
    if (strcmp (patn, parsed))
    {   move (LINES - 2, 0);
	addstr ("Parsed to \"");
	for (indx = 0; (indx < COLS - 15) && parsed [indx] ; indx++)
	    addch (parsed [indx]);
	addch ('\"');
	if (parsed [indx])
	    addstr ("...");
	Pause (0);
    }
    re_rtn = re_compile_pattern (parsed, strlen (parsed), &re_buf);
    if (re_rtn)
    {   move (LINES - 2, 0);
	printw ("Bad regexp: \"%s\"", re_rtn);
	Pause (0);
	free (re_buf.buffer);
	free (re_buf.fastmap);
	return;
    }

    re_compile_fastmap (&re_buf);
    
    for (indx = 0; indx < num_entries; indx++)
    {   if ((indx < 10) || ((indx % 10) == 9))
	{   move (LINES - 1, 0);
	    printw ("Highlighting seq %d", indx + 1);
	    refresh ();
	}
	len =  entry [indx] -> length;
	(entry [indx] -> seq) [len] = '\0';   /*  make sure  ...  */
	if (ignore_gaps)   {
	  hlite = thlite;
	  seq = tseq;
	  o_seq = entry [indx] -> seq; o_hlite = entry [indx] -> hlite;
	  n_seq = seq; n_hlite = hlite;
	  for (len = 0; *o_seq; o_seq++, o_hlite++)
	    if (*o_seq != '-')  {
	      *(n_seq++) = *o_seq;
	      *(n_hlite++) = *o_hlite;
	      len++;
	    }
	}
	else   {
	  hlite = entry [indx] -> hlite;
	  seq = entry [indx] -> seq;
	}
	istart = 0;
	hits = 0;  /*  number of matches  */
	while (re_search (&re_buf, seq, len, istart, len - istart, &re_regs) 
	    >= 0)
	{   

	    switch (hmm)  {
		case 0:
		    for (indx2 = re_regs.start [0]; 
			indx2 < re_regs.end [0]; indx2++)
			hlite [indx2] = pat_let;
		    break;
		case 1:
		    for (indx2 = re_regs.start [0]; 
			indx2 < re_regs.end [0]; indx2++)
			hlite [indx2] &= pat_let;
		    break;
		case 2:
		    for (indx2 = re_regs.start [0]; 
			indx2 < re_regs.end [0]; indx2++)
			hlite [indx2] |= pat_let;
		    break;
		case 3:
		    for (indx2 = re_regs.start [0]; 
			indx2 < re_regs.end [0]; indx2++)
			hlite [indx2] += (pat_let - '0');
		    break;
	    }
	    istart = re_regs.start [0] + 1;
	    hits ++;
	}
	entry [indx] -> new_hlite = hits;
	if (ignore_gaps)  {  /*  then we have to piece it together  */
	  o_hlite = thlite; o_seq = tseq;
	  n_hlite = entry [indx] -> hlite; n_seq = entry [indx] -> seq;
	  for (; *o_seq; o_seq++, o_hlite++, n_seq++, n_hlite++)  {
	    while (*n_seq == '-')  {
	      *n_hlite = *o_hlite;
	      n_seq++;
	      n_hlite++;
	    }
	    *n_hlite = *o_hlite;
	  }
	}
      }
    highlight_mode = H_MASK;
    disp_all ();
    free (re_buf.buffer);
    free (re_buf.fastmap);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

do_col_hlite ()
{   if (column_highlight)
	highlight_mode = H_COLUMN;
    else
	highlight_mode = H_NONE;
    disp_all ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

highlight_differences ()
{
    if ((highlight_model < 0) || (highlight_model > num_entries))
	highlight_model = 0;
    highlight_mode = H_DIFF;
    disp_all ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

do_hlite_diff (current_y)
int *current_y;
{   static char *hist [3], ick [200];
    char response [20];

    hist [0] = ick;
    if (hist [1])
    {   free (hist [1]);
	hist [1] = NULL;
    }
    sprintf (hist [0], "%d", *current_y + 1);
    win_prompt (stdscr, LINES - 2, 
	"Highlight differences from sequence",
		       response, hist,
		       0, "../Variables/HIGHLIGHT-DIFFERENCES");
    if (sscanf (response, "%d", &highlight_model) == 1)
        highlight_differences ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

t_hlite_diff (modl)
char *modl;
{   if (sscanf (modl, "%d", &highlight_model) == 1)
	highlight_differences ();
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

static struct re_pattern_buffer re_buf2;
static struct re_registers re_regs;
static char fastmapx [2200], search_string [300];
static int re_pat;
static int search_direction = 1;

set_search_string (string)
char *string;
{   char *re_rtn, parsed [3000];
    int indx;

    win_prompt (stdscr, LINES - 2,
	(search_direction == 1) ? "Search for" : "Search Backwards for",
	string, pattern_history, 0, "Set-Search");
    if (!re_buf2.allocated)
    {   re_buf2.allocated = 200;
	re_buf2.buffer = emalloc (200);
    }
    re_buf2.fastmap = fastmapx;
    if (ignore_case)
	re_buf2.translate = re_ignorecase;
    else
	re_buf2.translate = re_case;

    re_rtn = re_parse (string, parsed);
    if (re_rtn)
    {   move (LINES - 2, 0);
	printw ("Bad regexp: \"%s\"", re_rtn);
	Pause (0);
	return;
    }
    if (strcmp (string, parsed))
    {   move (LINES - 2, 0);
	addstr ("Parsed to \"");
	for (indx = 0; (indx < COLS - 15) && parsed [indx] ; indx++)
	    addch (parsed [indx]);
	addch ('\"');
	if (parsed [indx])
	    addstr ("...");
	Pause (0);
    }
    re_rtn = re_compile_pattern (parsed, strlen (parsed), &re_buf2);
    if (re_rtn)
    {   re_pat = 0;
	move (LINES - 2, 0);
	printw ("Bad regexp: \"%s\"", re_rtn);
	Pause (0);
	return;
    }
    re_compile_fastmap (&re_buf2);
    re_pat = 1;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */


search_back (current_y, current_x, mult)
int *current_y, *current_x, mult;
{   
    search_direction = -1;
    set_search_string (search_string);
    if (!re_pat)
	return;
    search_again (current_y, current_x, mult);
    search_direction = 1;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

search_back_again (current_y, current_x, mult)
int *current_y, *current_x, mult;
{   
    search_direction = -1;
    search_again (current_y, current_x, mult);
    search_direction = 1;
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

search (current_y, current_x, mult)
int *current_y, *current_x, mult;
{   
    set_search_string (search_string);
    if (!re_pat)
	return;
    search_again (current_y, current_x, mult);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

search_again (current_y, current_x, mult)
int *current_y, *current_x, mult;
{   int indx, len, pos;
    sq *this_seq;
    struct re_registers re_regs;
    char *seq, *n_seq, *o_seq;

    if (!re_pat)  {
	move (LINES - 2, 0);
	addstr ("No search expression set");
	Pause (0);
	return;
    }
    this_seq = entry [*current_y];
    if ((this_seq -> length < *current_x) && (search_direction == 1))  {
	    putchar ('\007');
	    return;
	}

    if (ignore_gaps)  {
	seq = (char *) alloca (this_seq -> length);
	o_seq = this_seq -> seq;
	n_seq = seq;
	indx = -1;
	for (len = pos = 0; *o_seq; o_seq++, pos++)  {
	    if (indx < 0)
		if (pos >= *current_x)
		    indx = (*o_seq == '-') ? (len - search_direction) : len;
	    if (*o_seq != '-')  {
		*(n_seq++) = *o_seq;
		len++;
	    }
	}
	*n_seq = '\0';
    }
    else  {
      seq = this_seq -> seq;
      len = this_seq -> length;
      indx = *current_x;
    }
    if (indx > len)
	indx = len;
    if ((search_direction == -1) && (indx < 1)) {
        putchar ('\07');
	return;
    }
    if (re_search (&re_buf2, seq, len, indx + search_direction,
	(search_direction == 1) ? (len - indx - 1) : (-1 * indx + 1), 
	&re_regs) >= 0) {
      if (ignore_gaps)  {
	seq [re_regs.start [0]] = '\0';
	o_seq = entry [*current_y] -> seq;
	pos = 0;
	while (*seq)   {
	  pos++;
	  seq++;
	  o_seq++;
	  while (*o_seq == '-')   {
	    pos++;
	    o_seq++;
	  }
	}
	*current_x = pos;
      }   
      else  {
	*current_x = re_regs.start [0];
      }
/*      this_seq -> seq + *current_x;  */
    }
    else
    {   move (LINES - 2, 0);
	printw ("RegEx \"%s\" not found", search_string);
	Pause (0);
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

align_pat ()
{   char patn [200];

    win_prompt (stdscr, LINES - 2, "Pattern to align on",
	patn, pattern_history, 0, "Pat-Align");
    text_align_pat (patn);
}

text_align_pat (pat)
/*  for now, align all sequences  */
char *pat;
{   int offsets [NUMBER_SEQ], indx, len, farthest, hit, not_found, ofs;
    struct re_pattern_buffer re_buf;
    char *re_rtn, parsed [2000], *seq;
    
    re_buf.allocated = 200;
    re_buf.buffer = emalloc (200);
    re_buf.fastmap = emalloc (2200);
    if (ignore_case)
      re_buf.translate = re_ignorecase;
    else
      re_buf.translate = re_case;

    if ((re_rtn = re_parse (pat, parsed)) ||
	(re_rtn = re_compile_pattern (parsed, strlen (parsed), &re_buf)))  {
      move (LINES - 2, 0);
      printw ("Bad regexp:  \"%s\"", re_rtn);
      Pause (0);
      free (re_buf.buffer);
      free (re_buf.fastmap);
      return;
    }

    farthest = not_found = 0;
    for (indx = 0; indx < num_entries; indx++)  {
      seq = entry [indx] -> seq;
      len = entry [indx] -> length;
      if ((hit = offsets [indx] = re_search (&re_buf, seq, len, 0, len, 0))
	  < 0)  {
    	move (LINES - 2, 0);
	printw ("Pattern not found in locus %d", indx + 1);
	/*Pause (0);*//* (PWK) */
	not_found++;
      }
      else
	if (hit > farthest)
	  farthest = hit;
    }
    
    move (LINES - 2, 0);
    printw ("Aligning pattern to offset %d (%d sequences missed)",
	    farthest + 1, not_found);
    Pause (0);
    for (indx = 0; indx < num_entries; indx++)  {
      hit = offsets [indx];
      if ((hit > 0) && (hit != farthest))  {
/*  see where we should insert gaps  */
	seq = entry [indx] -> seq;
	for (ofs = hit; (ofs > 0) && seq [ofs] != '.'; ofs--);
	if (ofs)   /*  if we hit period, add just past period  */
	  ofs++;
	move (LINES - 1, 0);
	printw ("%4d gaps at %d into %-40s", farthest - hit,
		ofs + 1,
		entry [indx] -> locus_name);
	refresh ();
	ins_1 (indx, ofs, farthest - hit, '-');
      }
    }
    Pause (0);
    disp_all ();
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/* (PWK) 07/22/96 */
jump_to_next_hlite (current_y, current_x, mult)
int *current_y, *current_x;  /*  zero based  */
{   char *stemp;
    int indx, indx2, len;


    indx = *current_y;
    indx2 = *current_x;
    for (; indx < num_entries; indx++) {
      stemp = entry [indx] -> hlite;
      len = entry [indx] -> length;
      for (; indx2 <= len; indx2++) {
	if (stemp [indx2] == '0')
	  break;
      }
      if (indx2 >= len) {
	indx++;
	indx2 = 0;
      }
      for (; indx2 <= len; indx2++) {
	if (stemp [indx2] != '0') {
	  *current_x = indx2;
	  *current_y = indx;
	  return;
	}
      }
      indx2 = 0;
    }
}

/* (PWK) 07/23/96 */
align_pat_part (current_y, current_x, mult)
int *current_x, *current_y;
{   char patn [200];
    char stemp [200], stemp2 [200];
    static char *range_list [10] = { NULL };
    int first, last;
    win_prompt (stdscr, LINES - 2, "Pattern to align on",
	patn, pattern_history, 0, "Pat-Align");

    sprintf (stemp2, "%d", *current_x + 1);
    if (range_list [1])
	free (range_list [1]);
    range_list [1] = NULL;
    if (range_list [0])
	free (range_list [0]);
    range_list [0] = stemp2;
    win_prompt (stdscr, LINES - 2,
	"    Start at position", stemp, range_list, 0, "SqStart");
    sscanf (stemp, "%d", &first); first--;

    sprintf (stemp2, "%d", first + 1 + mult);
    if (range_list [1])
	free (range_list [1]);
    range_list [1] = NULL;
    if (range_list [0])
	free (range_list [0]);
    range_list [0] = stemp2;
    win_prompt (stdscr, LINES - 2,
	"    End at position", stemp, range_list, 0, "SqEnd");
    sscanf (stemp, "%d", &last);

    move (LINES - 2, 0);
    text_align_pat_part (first, last, patn);
}

text_align_pat_part (first, last, pat)
int first, last;
char *pat;
{   int offsets [NUMBER_SEQ], indx, len, farthest, hit, not_found, ofs;
    struct re_pattern_buffer re_buf;
    char *re_rtn, parsed [2000], *seq;
    
    re_buf.allocated = 200;
    re_buf.buffer = emalloc (200);
    re_buf.fastmap = emalloc (2200);
    if (ignore_case)
      re_buf.translate = re_ignorecase;
    else
      re_buf.translate = re_case;

    if ((re_rtn = re_parse (pat, parsed)) ||
	(re_rtn = re_compile_pattern (parsed, strlen (parsed), &re_buf)))  {
      move (LINES - 2, 0);
      printw ("Bad regexp:  \"%s\"", re_rtn);
      Pause (0);
      free (re_buf.buffer);
      free (re_buf.fastmap);
      return;
    }

    farthest = not_found = 0;
    for (indx = 0; indx < num_entries; indx++)  {
      seq = entry [indx] -> seq;
      len = entry [indx] -> length;
      /* if ((hit = offsets [indx] = re_search (&re_buf, seq, len, 0, len, 0))
	  < 0)  { */
      if ((hit = offsets [indx] = re_search (&re_buf, seq, len, first,
					     last - first + 1, 0)) < 0)  {
	move (LINES - 2, 0);
	printw ("Pattern not found in locus %d", indx + 1);
	Pause (0);
	not_found++;
      }
      else
	if (hit > farthest)
	  farthest = hit;
    }
    
    move (LINES - 2, 0);
    printw ("Aligning pattern to offset %d (%d sequences missed)",
	    farthest + 1, not_found);
    Pause (0);
    for (indx = 0; indx < num_entries; indx++)  {
      hit = offsets [indx];
      if ((hit > 0) && (hit != farthest))  {
/*  see where we should insert gaps  */
	seq = entry [indx] -> seq;
	for (ofs = hit; (ofs > 0) && seq [ofs] != '.'; ofs--);
	if (ofs)   /*  if we hit period, add just past period  */
	  ofs++;
	move (LINES - 1, 0);
	printw ("%4d gaps at %d into %-40s", farthest - hit,
		ofs + 1,
		entry [indx] -> locus_name);
	refresh ();
	ins_1 (indx, ofs, farthest - hit, '-');
      }
    }
    Pause (0);
    disp_all ();
}


align_hlite_pat_part (current_y, current_x, mult)
int *current_x, *current_y;
{   /*char patn [200];*/
    char stemp [200], stemp2 [200];
    static char *range_list [10] = { NULL };
    int first, last;
    /*win_prompt (stdscr, LINES - 2, "Pattern to align on",
	patn, pattern_history, 0, "Pat-Align");*/

    sprintf (stemp2, "%d", *current_x + 1);
    if (range_list [1])
	free (range_list [1]);
    range_list [1] = NULL;
    if (range_list [0])
	free (range_list [0]);
    range_list [0] = stemp2;
    win_prompt (stdscr, LINES - 2,
	"    Start at position", stemp, range_list, 0, "SqStart");
    sscanf (stemp, "%d", &first); first--;

    sprintf (stemp2, "%d", first + 1 + mult);
    if (range_list [1])
	free (range_list [1]);
    range_list [1] = NULL;
    if (range_list [0])
	free (range_list [0]);
    range_list [0] = stemp2;
    win_prompt (stdscr, LINES - 2,
	"    End at position", stemp, range_list, 0, "SqEnd");
    sscanf (stemp, "%d", &last);

    move (LINES - 2, 0);
    text_align_hlite_pat_part (first, last);
}

text_align_hlite_pat_part (first, last)
int first, last;
{   int offsets [NUMBER_SEQ], indx, indx2, len, farthest, hit, not_found, ofs;
    char *seq, *hlite, *pat;

    farthest = not_found = 0;
    for (indx = 0; indx < num_entries; indx++) {
      hlite = entry [indx] -> hlite;
      len = entry [indx] -> length;
      hit = 0;
      for (indx2 = first; indx2 < last; indx2++)
	if (hlite [indx2] != '0') {
	  hit = offsets [indx] = indx2 + 1;
	}
      if (hit <= 0) {
	move (LINES - 2, 0);
	printw ("Pattern not found in locus %d", indx + 1);
	Pause (0);
	not_found++;
      }
      else
	if (hit > farthest)
	  farthest = hit;
    }
    
    move (LINES - 2, 0);
    printw ("Aligning pattern to offset %d (%d sequences missed)",
	    farthest + 1, not_found);
    Pause (0);
    for (indx = 0; indx < num_entries; indx++)  {
      hit = offsets [indx];
      if ((hit > 0) && (hit != farthest))  {
/*  see where we should insert gaps  */
	seq = entry [indx] -> seq;
	for (ofs = hit; (ofs > 0) && seq [ofs] != '.'; ofs--);
	if (ofs)   /*  if we hit period, add just past period  */
	  ofs++;
	move (LINES - 1, 0);
	printw ("%4d gaps at %d into %-40s", farthest - hit,
		ofs + 1,
		entry [indx] -> locus_name);
	refresh ();
	ins_1 (indx, ofs, farthest - hit, '-');
      }
    }
    /*Pause (0);*/
    disp_all ();
}
