#ifndef LINT
static char *sccs_sid = "@(#)prottrans.c	0.9 3/5/99 MASE ";
#endif

#include "edseq.h"
#include "extern.h"
#ifdef sparc
#include <alloca.h>
#endif
#include "../lib/faulkn.h"

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** *
 * Routines added by Paul Klonowski to allow on the fly translation
 * of nucleic acid sequence to protein
 * ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

char *getenv ();
sq *prottrans_sequence;
extern int transl_ignore_gaps;

prot_trans (current_y)
int *current_y;
{   sq *new, *curr;
    char *user;
    long tim;
    int indx, model_num, new_position, transl_type, frame;

    transl_type = 1;
    frame = 0;

    user = getenv ("USER");
    if (!user || !*user)
        user = "UNKNOWN";

    if (transl_type == 3) {  /* One Letter Protein to Three  */
      new -> length *= 3;
    }

    new = (sq *) ecalloc (1, sizeof (sq));
    new -> modified = 1;
    prottrans_sequence = new;
    time (&tim);

    curr = entry [*current_y];

    if (prottrans_sequence -> length)
    {   free (prottrans_sequence -> seq);
        free (prottrans_sequence -> hlite);
    }
    else
      num_per_win--;
    new -> length = curr -> length;
    new -> allocated = curr -> length + 1000;
    new -> seq = emalloc (curr -> allocated + 10);
    new -> hlite = emalloc (curr -> allocated + 10);
    new -> comments = emalloc (500 + strlen (curr -> comments));
    sprintf (new -> comments,
             "; Created in MASE on %s;    By:  %s\n; translation of locus %s\n",
             ctime (&tim), user, curr -> locus_name);
    strcat (new -> comments, curr -> comments);
    bcopy (curr -> seq, new -> seq, new -> length + 10);
    bcopy (curr -> hlite, new -> hlite, new -> length + 10);
    strcat (new -> comments, "; TRANSLATED\n");
    if (transl_ignore_gaps)
      strip_seq (new -> seq);
    switch (transl_type)  {
    case 1:  /* Three letter  */
      transl_3_let ((new -> seq) + frame);
      break;
    case 2:  /* One Letter  */
      transl_1_let ((new -> seq) + frame);
      break;
    case 3:
      transl_aa3_let (curr -> seq, new -> seq);
      break;
    }
    if (transl_ignore_gaps)
      seq_1_sync (curr, new);
    new -> length = strlen (new -> seq);

    strcpy (prottrans_sequence -> from_file, "Prottrans-Sequence");
    strcpy (prottrans_sequence -> locus_name, "PROTTRANS");
    disp_all ();
}


prottrans_off ()
/*  turn off display of translated sequence  */
{
    if (prottrans_sequence -> length)
    {   free (prottrans_sequence -> seq);
        free (prottrans_sequence -> hlite);
        prottrans_sequence -> seq = "";
        prottrans_sequence -> hlite = "";
        prottrans_sequence -> length = 0;
        num_per_win++;
    }
    disp_all ();
}

save_prottrans ()
{   char out_name [300];

    out_name [0] = '\0';
    fsave_prottrans (out_name);
}

fsave_prottrans (out_name)
char *out_name;
{   FILE *outf;
    static char *hist [300];

    if (!prottrans_sequence -> length)
    {   move (LINES - 2, 0);
        addstr ("No translation generated");
        Pause (0);
        return;
    }
    outf = w_open_file (out_name, "w", hist);
    fputs (prottrans_sequence -> comments, outf);
    fprintf (outf, "%s\n", prottrans_sequence -> locus_name);
    write_sequence (prottrans_sequence -> seq, outf);
    fclose (outf);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
